
#include "Appevent.ch"
#include "Common.ch"
#include "Gra.ch"
#include "Xbp.ch"
#include "Font.ch"
#include "Directry.ch"

#define CRLF CHR(13)+CHR(10)

#pragma Library( "XppUi2.lib" )

PROCEDURE AppSys
RETURN

PROCEDURE Main
LOCAL oDlg, oXbp, mp1, mp2, nEvent, aSize
LOCAL oBrowse

   SET EPOCH TO YEAR( DATE() ) - 50
   SET DATE GERMAN

   aSize := AppDesktop():currentsize()

   oDlg := XbpDialog():new(AppDesktop(),,{0,0},aSize,, .F. )
   oDlg:taskList                 := .T.
   oDlg:drawingArea:clipChildren := .T.
   oDlg:title                    := 'Test'
   oDlg:create()
   oDlg:drawingArea:setFontCompoundName( '9.Arial' )
   CenterControl( oDlg )
   SetAppWindow( oDlg )

   aSize:= oDlg:drawingArea:currentSize()

   oBrowse := OWbrowse():new( oDlg:drawingArea,, { 0, 0 }, aSize,, .F. )

   oBrowse:aTage         := LeerArray()
   oBrowse:cursorMode    := XBPBRW_CURSOR_CELL
   oBrowse:create()

   oBrowse:MakeTage()
   oBrowse:MakeCol()
   oBrowse:Highlight( DTOC(DATE()) )

   oDlg:show()
   oBrowse:show()
   SetAppFocus( oBrowse )

   DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO
   QUIT

RETURN

CLASS OWbrowse FROM XbpBrowse
PROTECTED:
   VAR cHighlight

EXPORTED:
   VAR aTage, nLastRec, nRecno

   METHOD destroy()
   METHOD init()
   METHOD create()
   METHOD customDrawCell()
   METHOD Highlight()
   METHOD Skip()

   METHOD MakeTage()
   METHOD MakeCol()
   VAR nRowHilite, nColHilite

   METHOD ShowPrevMonth()
   METHOD ShowNextMonth()

   VAR nStartDay
   VAR nStartMonth
   VAR nStartYear

ENDCLASS

METHOD OWbrowse:destroy
   ::cHighlight:= nil
   ::XbpBrowse:destroy()
RETURN self

METHOD OWbrowse:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::XbpBrowse:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::drawMode     := XBP_DRAW_OWNER
   ::cHighlight   := ''

   ::nRowHilite   := 1
   ::nColHilite   := 1

   ::nStartDay      := DAY(DATE())
   ::nStartMonth    := Month(DATE())
   ::nStartYear     := Year(DATE())

RETURN self

METHOD OWbrowse:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::XbpBrowse:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::childList()[4]:type := XBPSTATIC_TYPE_TEXT
   ::childList()[4]:setColorBG( GRA_CLR_WHITE )
   ::childList()[4]:configure()

   ::HScroll        := .F.
   ::VScroll        := .F.
   ::SizeCols       := .F.

   ::nLastRec       := LEN(::aTage)
   ::nRecno         := 1
   ::SkipBlock      := {|nSkip,oBrowse| ::Skip(nSkip,oBrowse) }
   ::GoTopBlock     := {|| ::nRecno := 1 }
   ::GoBottomBlock  := {|| ::nRecno := LEN(::aTage) }
   ::PosBlock       := {|| ::nRecno }
   ::PhyPosBlock    := {|| ::nRecno }
   ::LastPosBlock   := {|| LEN(::aTage) }
   ::FirstPosBlock  := {|| 1 }

   ::hitTopBlock    := {|| ::ShowPrevMonth()  }
   ::hitBottomBlock := {|| ::ShowNextMonth()  }

RETURN self

METHOD OWbrowse:customDrawCell( oPS, aInfo )
LOCAL xData, nPos
LOCAL nRow     := aInfo[ XBP_DRAWINFO_ITEM   ] // Nummer der Zeile, die die Zelle enthlt
LOCAL nAction  := aInfo[ XBP_DRAWINFO_ACTION ] // Aktion, die das Ereignis xbeP_CustomDrawCell ausgelst hat
LOCAL nState   := aInfo[ XBP_DRAWINFO_STATE  ] // Aktueller Zustand der Zelle
LOCAL aRect    := aInfo[ XBP_DRAWINFO_RECT   ] // Ausgaberechteck fr die Zeichenoperation
LOCAL oArea    := aInfo[ XBP_DRAWINFO_AREA   ] // Betroffener Zellbereich (Kopfzeile, Datenbereich,Fusszeile der Spalte)
LOCAL oCol     := aInfo[ XBP_DRAWINFO_COLUMN ] // XbpColumn-Objekt, das die Zelle enthlt

LOCAL aStartPoint
LOCAL aEndPoint

*ALTD()
*   IF aInfo[ XBP_DRAWINFO_AREA ] = aInfo[ XBP_DRAWINFO_COLUMN ]:dataArea

     xData:= aInfo[ XBP_DRAWINFO_AREA ]:getCell( aInfo[ XBP_DRAWINFO_ITEM ] )

     IF xData <> nil

       aStartPoint := aInfo[ XBP_DRAWINFO_RECT ]
       aEndPoint   := { aInfo[ XBP_DRAWINFO_RECT, 3 ], aInfo[ XBP_DRAWINFO_RECT, 4 ] }

       GraCaptionStr( oPS,;
                      aStartPoint,;
                      aEndPoint,;
                      xData,;
                      XBPALIGN_TOP+XBPALIGN_LEFT+XBPALIGN_WORDBREAK )

        IF ( nPos:= At( ::cHighlight, xData ) ) > 0

           oPS:setColor( IIF( aInfo[ XBP_DRAWINFO_STATE ] = XBP_DRAWSTATE_SELECTED, XBPSYSCLR_MENUHILITE, XBPSYSCLR_WINDOWSTATICTEXT ) )

           GraCaptionStr( oPS,;
                          aInfo[ XBP_DRAWINFO_RECT ],;
                          { aInfo[ XBP_DRAWINFO_RECT, 3 ], aInfo[ XBP_DRAWINFO_RECT, 4 ] },;
                          xData,;
                          XBPALIGN_TOP+XBPALIGN_LEFT+XBPALIGN_WORDBREAK )

           oPS:setColor( GRA_CLR_RED )

           IF nPos = 1
              GraCaptionStr( oPS, aInfo[ XBP_DRAWINFO_RECT ], { aInfo[ XBP_DRAWINFO_RECT, 3 ], aInfo[ XBP_DRAWINFO_RECT, 4 ] }, ::cHighlight, XBPALIGN_TOP+XBPALIGN_LEFT+XBPALIGN_WORDBREAK )

           ELSE
              aRect:= GraQueryTextBox( oPS, Left( xData, nPos - 1 ) )

              aStartPoint := { aInfo[ XBP_DRAWINFO_RECT, 1 ] + aRect[ 3, 1 ], aInfo[ XBP_DRAWINFO_RECT, 2 ] }
              aEndPoint    := { aInfo[ XBP_DRAWINFO_RECT, 3 ], aInfo[ XBP_DRAWINFO_RECT, 4 ] }

              GraCaptionStr( oPS,;
                             aStartPoint,;
                             aEndPoint,;
                             ::cHighlight,;
                             XBPALIGN_TOP+XBPALIGN_LEFT+XBPALIGN_WORDBREAK )
           ENDIF
           RETURN .F.
        ENDIF
      ENDIF
*   ENDIF

RETURN .T.

METHOD OWbrowse:Highlight( cStr )
LOCAL i

   ::cHighlight:= cStr
   ::invalidateRect()

   ::deHilite()

   ::colPos := ::nColHilite
   ::rowPos := ::nRowHilite

   FOR i := 1 TO ::nRowHilite -1
      ::down()
      DO WHILE .NOT. ::forceStable()
         SLEEP(0)
      ENDDO
   NEXT

   ::hilite()

RETURN self

METHOD OWbrowse:Skip( nSkip )
   LOCAL nCanSkip

   IF ::nRecno + nSkip < 1               // "BoF"
      nCanSkip := 1 - ::nRecno
*      TONE ( 1000 )
   ELSEIF ::nRecno + nSkip > ::nLastRec  // "EoF"
      nCanSkip := ::nLastRec - ::nRecno
*      TONE ( 500 )
   ELSE
      nCanSkip := nSkip
   ENDIF

   ::nRecno += nCanSkip

RETURN nCanSkip

METHOD OWbrowse:ShowPrevMonth
// under Construction
RETURN self

METHOD OWbrowse:ShowNextMonth
// under Construction
RETURN self

METHOD OWbrowse:MakeCol()
LOCAL oColumn
LOCAL PRES_PARAM :=  { ;       // Presentation Parameter fuer den Browser
         {XBP_PP_COL_DA_ROWWIDTH       , 1                            }, ;
         {XBP_PP_COL_DA_ROWHEIGHT      , 100                          }, ;
         {XBP_PP_COL_DA_COMPOUNDNAME   , FONT_DEFPROP_SMALL           }, ;
         {XBP_PP_COL_DA_HILITE_FGCLR   , GRA_CLR_BLACK                }, ;
         {XBP_PP_COL_DA_HILITE_BGCLR   , GRA_CLR_GREEN                }, ;
         {XBP_PP_COL_DA_CELLALIGNMENT  , XBPALIGN_TOP+XBPALIGN_LEFT+XBPALIGN_WORDBREAK}}

LOCAL aSize:= ::setparent():currentSize()

LOCAL nCol
LOCAL bBlock

   PRES_PARAM[1,2] := INT(aSize[1]/7)
   PRES_PARAM[2,2] := INT(aSize[2]/5)

#IFDEF MAKEERROR

   FOR nCol = 1 TO 7
      oColumn := XbpColumn():new( ::XbpBrowse,,,,PRES_PARAM )
      oColumn:drawMode := XBP_DRAW_OWNER

      bBlock           := "{|| ::XbpBrowse:aTage[::XbpBrowse:nRecno,"+STR(nCol,3)+"] }"
      oColumn:dataLink := &bBlock

      ::XbpBrowse:addColumn( oColumn )
   NEXT

#ELSE

   oColumn := XbpColumn():new( ::XbpBrowse,,,,PRES_PARAM )
   oColumn:drawMode := XBP_DRAW_OWNER
   oColumn:dataLink := {|| ::aTage[::nRecno,1] }
   ::addColumn( oColumn )

   oColumn := XbpColumn():new( ::XbpBrowse,,,,PRES_PARAM )
   oColumn:drawMode := XBP_DRAW_OWNER
   oColumn:dataLink := {|| ::aTage[::nRecno,2] }
   ::addColumn( oColumn )

   oColumn := XbpColumn():new( ::XbpBrowse,,,,PRES_PARAM )
   oColumn:drawMode := XBP_DRAW_OWNER
   oColumn:dataLink := {|| ::aTage[::nRecno,3] }
   ::addColumn( oColumn )

   oColumn := XbpColumn():new( ::XbpBrowse,,,,PRES_PARAM )
   oColumn:drawMode := XBP_DRAW_OWNER
   oColumn:dataLink := {|| ::aTage[::nRecno,4] }
   ::addColumn( oColumn )

   oColumn := XbpColumn():new( ::XbpBrowse,,,,PRES_PARAM )
   oColumn:drawMode := XBP_DRAW_OWNER
   oColumn:dataLink := {|| ::aTage[::nRecno,5] }
   ::addColumn( oColumn )

   oColumn := XbpColumn():new( ::XbpBrowse,,,,PRES_PARAM )
   oColumn:drawMode := XBP_DRAW_OWNER
   oColumn:dataLink := {|| ::aTage[::nRecno,6] }
   ::addColumn( oColumn )

   oColumn := XbpColumn():new( ::XbpBrowse,,,,PRES_PARAM )
   oColumn:drawMode := XBP_DRAW_OWNER
   oColumn:dataLink := {|| ::aTage[::nRecno,7] }
   ::addColumn( oColumn )

#ENDIF

RETURN self

METHOD OWbrowse:MakeTage()
LOCAL nTag
LOCAL nDay      := ::nStartDay
LOCAL nMonth    := ::nStartMonth
LOCAL nYear     := ::nStartYear
LOCAL nCol
LOCAL nCount
LOCAL nRow

   nTag := STOD(STRZERO(nYear,4)+STRZERO(nMonth,2)+"01")
   nTag := DoW(nTag)

   nTag--
   IF nTag = 0
      nTag := 7
   ENDIF

   nCount := 1
   nRow := 0

   FOR nCol = 1 TO nTag
      ::aTage[1][nCol] := " "
   NEXT

   FOR nCol = nTag TO 7
      ::aTage[1][nCol] := DTOC(CTOD(STRZERO(nCount,2)+"."+STRZERO(nMonth,2)+"."+STRZERO(nYear,4)))
      nCount++
   NEXT

   nRow := 2
   FOR nRow = 2 TO 5
      nCol := 1
      FOR nCol = 1 TO 7
         ::aTage[nRow][nCol] := DTOC(CTOD(STRZERO(nCount,2)+"."+STRZERO(nMonth,2)+"."+STRZERO(nYear,4)))
         IF nDay = nCount
            ::nRowHilite   := nRow
            ::nColHilite   := nCol
         ENDIF
         nCount++
      NEXT
   NEXT

RETURN ::aTage

FUNCTION LeerArray()
LOCAL aRet := {{" 1"," 2"," 3"," 4"," 5"," 6"," 7"},;
               {" 8"," 9","10","11","12","13","14"},;
               {"15","16","17","18","19","20","21"},;
               {"22","23","24","25","26","27","28"},;
               {"29","30","31","32","33","34","35"}}

RETURN aRet

*
*
*